#include "funciones.h"

#pragma warning(disable : 4996) // se desactiva los errores relacionados con la seguridad de las funciones

void refactor(char marcador[]) {	//elimina el marcador :
	int i, reaux;
	reaux = 0;
	for (i = 0; i < 200 && reaux == 0; i++) {
		if (marcador[i] == ':' && reaux == 0) {		//se cambia : por \n
			marcador[i] = '\n';
			reaux = 1;	//se marca a 1 para salir
		}
	}
}

void keepalive(){ //funcin que realiza los ping a las mquinas de una red

	int auxiliar; //Defino auxiliar
	FILE *fichero; //creo parametro de fichero
	char archivo[100], direccion[100], validar[40]; //creo los campos que guardaran los parametros de la direccin

	auxiliar = 0;

	scanf("%s",&archivo); //leemos de teclado
	fichero = fopen(archivo, "r"); //abrimos el archivo recogido

	if(fichero==NULL){	//validacion en la apertura del archivo
		printf("No se ha podido abrir el fichero.\n");
		exit(1);	//salida por error
	}

	printf("El valor de archivo: \n%s\n",archivo); //se muestran los valores del archivo
	printf("\n");

	while(auxiliar != EOF){	//se recorre el archivo
		auxiliar = fgetc(fichero);
		printf("%c",auxiliar);
	}
	printf("\n");

	rewind(fichero);	//va al principio del archivo
	while (!feof(fichero)) { 	//se recorre todo el archivo
        fscanf(fichero, "%s", direccion); //se va copiando la informacin
		pingcheck(direccion, validar); //se realiza el ping
    }

	printf("\n");
	fclose(fichero);

	system ("pause"); //excepcin que pausa la ejecucin
	system("cls");  //excepcin que borra la pantalla
}

void dnscheck(){  //funcin que realiza la comparativa de dos pings

	int dnaux1, dnaux2; //parametros auxiliares
	char dnerror[20]= "ERROR", dnsck1[40], dnip[40]; //parametros pertenecientes a dns
    char target1[40], target2[40]; //parametros comparativa

    dnaux1 = 0;
    dnaux2 = 0;

    printf("Introduzca la direccion del primer DNS\n");
    scanf("%s", dnsck1);

    printf("Introduzca la direccion del segundo DNS\n");
    scanf("%s", dnip);

	pingcheck(dnsck1, target1); //se realiza la accin

	dnaux1 = atoi(target1); //se hace un casting a entero
	  if(dnaux1 > 0){
    	printf("La media de la ip %s es %i ms.\n",dnsck1, dnaux1);	//se muestran los resultados
	}
	else{
		printf("No responde %s\n",dnsck1);
	}

	pingcheck(dnip, target2);  //se llama a la funcin pingcheck
    dnaux2 = atoi(target2);		//se hace un casting a entero
    if(dnaux2 > 0){
    	printf("La media de la ip %s es %i ms.\n",dnip, dnaux2);
	}
	else{
		printf("No responde %s\n",dnip);
	}

	//acciones de comparacin
 	if(dnaux1 == 0 || dnaux2 == 0 ){
 		printf("No se puede comparar porque  una de las dns no funciona.\n");
 		system("pause");
		 exit(1);
	 }

	 if(dnaux1 > dnaux2){
	 	printf("La DNS mas rapida es %s con una media de %i ms.\n",dnip, dnaux2);
	 }
	 else if(dnaux1 == dnaux2){
	 	printf("Ambas DNS son igual de rapidas\n");
	 }
	 else if(dnaux1 < dnaux2){
	 	printf("La DNS mas rapida es %s con una media de %i ms.\n",dnsck1, dnaux1);
	 }
        system("pause");
		 system ("cls");
}

void pingcheck(char direccionIP[], char validar[]){ //funcin que realiza los pings de las direcciones

	//int inicial = 0;
	char tiempo[60], medidatiempo[20] = "ms";
	char error[25] = "ERROR", llamada[100] = "ping", darchivo[100] = ">ips.txt";

    FILE* ficheropingcheck;
    strcat(llamada, " ");	//se aade simbolo
    strcat(llamada, direccionIP);	//se aade ip
    strcat(llamada, darchivo);		//se aade ruta del archivo
    system(llamada);	//se aade el resultado

    ficheropingcheck = fopen("ips.txt", "r"); //apertura del fichero en modo lectura
    if (ficheropingcheck == NULL)
        exit(1);
    else {

        fseek(ficheropingcheck, -6, SEEK_END); //quitamos los ultimos espacios
        fgets(tiempo, 15, ficheropingcheck);	//obtenemos el resultado

    }
    if (strstr(tiempo, medidatiempo)) { 	//comprobamos medida de tiempo
        strcpy(validar, tiempo); //copiamos el dato
        printf("\nEl Ping %s responde correctamente.\n", direccionIP);

    }
    else {
        printf("\nEl Ping %s NO responde.\n", direccionIP);	//sino mostramos error
        strcpy(validar, error);	// copiamos el dato

    }
    fclose(ficheropingcheck); //cierre de archivo
}

void interfaces(){

	//creacion de variables para almacenar distintos resultados
	FILE *ifichero;
	FILE *ifichero2;
	FILE *ifichero3;
	FILE *ifichero4;

	int iaux, iaux2;
	char inet1[150], inet2[25] = "Adaptador", line[150], iopcion; //datos adaptadores
 	char configuracion[200], direccionip[15] = "IPv4", subnet[15] = "subred", gateway[100] = "Puerta de enlace", dns[20] = "Servidores DNS", protocol[150] = "NetBIOS"; //caracteristicas adaptador
    system("ipconfig/all>configred.txt"); //llamada archivo de configuracin
    system("del interfaces.txt");
	system("netsh interface show interface>>interfaces.txt"); //guardamos informacin

	iaux = 0;
	iaux2 = 0;

	ifichero2 = fopen("interfaces.txt", "r");
	ifichero3 = fopen("interfacesdns.txt", "a");
	ifichero4 = fopen("interfacesconf.txt", "a");

    printf("Introduce el nombre del adaptador de red del que quieres conocer la configuracion.\n");

    while (!feof(ifichero2)){	//leemos el archivo entero
	  	fgets(line, 100, ifichero2);
	  	printf("%s", line);
    }

    printf("Introduce el nombre:");
    fflush(stdin);  //recogemos adaptador
    fgets(inet1,100,stdin); // adaptador introducido

	fputs(inet1,ifichero4);  //metemos los datos inet1 en el fichero

    printf("\nEl adapatador es: %s\n\n", inet1);	// se muestra la informacin

    ifichero = fopen("configred.txt", "r");	//se abre el archivo
	rewind(ifichero); //rebobinamos el fichero
	  while (!feof(ifichero)){	//leemos el archivo entero
	  	fgets(line, 100, ifichero);
		refactor(line);


	  	if (strstr(line, inet1)){	//compara la informacin
	  		 do{

	  		 	fgets(line, 200, ifichero); //se recoge la informacin
	  		 	if (strstr(line, direccionip)) {	//se realiza la comparacin

                    printf("La IP es %s\n", line + 45); //se selecciona la informacin relevante
                }
                 if (strstr(line, subnet)) {  //se revisa subnet

                    printf("La mascara subred es %s\n", line + 45);
                }
                if (strstr(line, gateway)) { //se revisa gateway

                    printf("La puerta de enlace es %s\n", line + 45);
                }
                if (strstr(line, dns)){	//se revisa dns

                    printf("El primer DNS es %s\n", line + 45);
                    ifichero3 = fopen("interfacesdns.txt", "a");
                    fprintf(ifichero3, line + 47);
                    fclose(ifichero3);
                    fgets(line, 200, ifichero);

                    if(strstr(line, protocol)){	//se revisa protocol
                    	 iaux2 = 1; //se marca para salir
					}
					else{	//se imprime resultado
						printf("El segundo dns es : %s\n", line + 39);

						ifichero3 = fopen("interfacesdns.txt", "a");
                        fprintf(ifichero3, line+39);

                        fgets(line, 100, ifichero);

						if(strstr(line, protocol)){ // si esta la cadena de caracteres netbios se sale
                    	 iaux2 = 1;
					}
					else{
						printf("El tercer dns es: %s\n", line + 39);
						ifichero3 = fopen("interfacesdns.txt", "a");
                        fprintf(ifichero3, line+39);

					}
					}

                }
                if (strstr(line, inet2)) {
                    iaux2 = 1;
                }
			   }while(line != inet2 && iaux2 == 0); //se compara interfaces
		  }
	  }

// se cierran los archivos
fclose(ifichero3);
fclose(ifichero2);
fclose(ifichero);
fclose(ifichero4);

system ("pause");
system ("cls");

}
